package com.jz.dmp.modules.service.impl;

import java.util.Set;
import java.util.concurrent.TimeUnit;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import com.jz.dmp.modules.service.AtomBaseCacheService;

@Service
public class AtomBaseCacheServiceImpl<T> implements AtomBaseCacheService<T> {
	

	@Autowired
	private RedisTemplate<String, T> redisTemplate;

	@Override
	public void setValue(String key, T value) {		
		redisTemplate.opsForValue().set( key, value);
	}

	@Override
	public T getValue(String key) {
		return redisTemplate.opsForValue().get(key);
	}

	@Override
	public void setValue(String key, T value, Long time) {
		redisTemplate.opsForValue().set( key, value, time, TimeUnit.SECONDS);
	}

	@Override
	public boolean setNEX(String key, T value) {
		return redisTemplate.opsForValue().setIfAbsent(key, value);
	}

	

	@Override
	public T remove(String key) {
		T value = redisTemplate.opsForValue().get(key);
		redisTemplate.delete(key);
		return value;
	}

	@Override
	public Boolean expire(String key, long timeout, TimeUnit unit) {
		return redisTemplate.expire(key,timeout,java.util.concurrent.TimeUnit.SECONDS);
	}
	

	@Override
	public void delKyes(String key) {
		Set<String> keys = redisTemplate.keys(key+"*");
	    redisTemplate.delete(keys);
	}
	


}
